/* INITUSER.C - Program fr initiering av anvndardata. */
/* (c) 1989, 1990 Nils Hammar */

/*	Programmet fr anvndas av vem som helst, helt eller delvis
	under frutsttning att kllan anges.
	Om koden anvnds i kommersiella programsystem gller det att
	kllan skall anges i dokumentationen.
*/

#define LOGIN

#include <stdio.h>
#include <string.h>
#include "global.h"

#ifndef MSDOS
#include <unistd.h>
#endif


/*	Skapa en helt ny inloggningsfil i systemet. */

int	main(argc, argv)
int	argc;
char	*argv[];
{
	FILE		*f;
	long int	position;
	int		z, i, users;

/*	Hll kompilatorn lugn... */

	z=argc;
	z=strcmp(argv[0], "");

/*	Starta... */

	printf("\n\nThe user register files will now be created...\n");

#ifdef MSDOS
	f=fopen("USER.DAT","wb");
#else
	f=fopen("USER.DAT","w");
#endif

/*	Initiera litet defaultvrden fr systemet. */

/*	Namnet p BBS:en. */
	strcpy(sysdata.systemname, SYSTEMVERSION);

/*	BBS:ens adress. */
	sysdata.zone=0;
	sysdata.region=0;
	sysdata.net=0;
	sysdata.node=0;
	sysdata.point=0;
	sysdata.moetstatus=0;		/* Anvnds ej. */
	sysdata.operator=0;		/* Number of bells when calling
					   for SYSOP. */
	sysdata.lastread=0;
	sysdata.maintprivs=0;		/* Default privilegies for new */
	sysdata.fileprivs=0;		/* users. */
	sysdata.textprivs=0;
	sysdata.failtype=0;
	sysdata.pointnet=0;		/* Fake-net number. */
	sysdata.sysflags=0;		/* Special flags. (For debugging.) */
	sysdata.minpacks=10;		/* Don't allow packing below
					   this point. */
	sysdata.packlimit=50;		/* Let this number of texts
					   remain when packing. */
	sysdata.routeage=36;		/* Re-route at this age. */
	sysdata.packetnumber=0L;	/* PKT file serial number */
	sysdata.timeout=600L;		/* Inactive timeout in seconds */

/*	Skapa en frsta anvndare i systemet. */
	strcpy(user.dummy,"\376");		/* Poststart. */
	strcpy(user.username,"Nils Hammar");	/* Namn */
	strcpy(user.password,"");		/* Lsenord */
	strcpy(user.adress,"Storstigen 35B");	/* Adress */
	strcpy(user.postnr,"S-951 39");		/* Postnummer */
	strcpy(user.postadress,"LULE");	/* Ort */
	strcpy(user.tel,"+46 +920-12426");	/* Telefon */
	strcpy(user.lastlogin,"");		/* Tid senast inloggad. */
	strcpy(user.termtype,"VT100");		/* Terminaltyp */
	user.lines=24;				/* Rader hos terminalen. */
	user.columns=80;			/* Kolumner hos terminalen */
	user.charset=0;				/* Teckenuppsttning vid
						   uppringd frbindelse. */
	user.maintprivs=65535;			/* Underhllsrttigheter
						   Fr ej ndras! */
	user.fileprivs=65535;			/* Filrttigheter
						   Fr ej ndras! */
	user.textprivs=65535;			/* Textrttigheter
						   Fr ej ndras! */
	user.totaltime=0L;			/* Totalt inloggad tid. */
	user.maxlogintime=3600;			/* Maximalt tillten tid
						   att vara inloggad. */
	user.status=0;				/* Div statusflaggor. */

/*	Initiera tabell ver mten att vara medlem i. */

	for(i=0;i<256;i++)
	{
		user.memberinfo[i].moetstatus=0;
		user.memberinfo[i].lastread=0;
	}

/*	Stt rttigheter till de frsta mtena. */

	user.memberinfo[1].moetstatus=63;
	user.memberinfo[2].moetstatus=63;
	user.memberinfo[3].moetstatus=63;

	if (fseek(f, 0L, SEEK_SET) != 0)
	{
		perror(INITUSER1);
		fclose(f);
		exit(9);
	}

	users=1;

	z=fwrite((char *) &users, sizeof(int), 1, f);

	if (fseek(f, (unsigned long int) sizeof(int), SEEK_SET) != 0)
	{
		perror(INITUSER1);
		fclose(f);
		exit(9);
	}

	z=fwrite((char *) &sysdata, sizeof(systemdata), 1, f);

	position=(unsigned long int) sizeof(userrec);
	if (fseek(f, position, SEEK_SET) != 0)
	{
		perror(INITUSER1);
		fclose(f);
		exit(9);
	}

	z=fwrite((char *) &user, sizeof(userrec), 1, f);

	fclose(f);

	printf("\nRecord size in USER.DAT : %d\n",sizeof(userrec));

#ifdef MSDOS
	f=fopen("AREAS.DAT","wb");
#else
	f=fopen("AREAS.DAT","w");
#endif

	users=0;
	z=fwrite((char *) &users, sizeof(int), 1, f);

	fclose(f);

	return(0);
}
